// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `DNS.ice'

#include <DNS/DNS.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Tartarus__iface__DNS__Zone__getName_name = "getName";

static const ::std::string __Tartarus__iface__DNS__Zone__addRecord_name = "addRecord";

static const ::std::string __Tartarus__iface__DNS__Zone__addRecords_name = "addRecords";

static const ::std::string __Tartarus__iface__DNS__Zone__clearAll_name = "clearAll";

static const ::std::string __Tartarus__iface__DNS__Zone__replaceRecord_name = "replaceRecord";

static const ::std::string __Tartarus__iface__DNS__Zone__dropRecord_name = "dropRecord";

static const ::std::string __Tartarus__iface__DNS__Zone__countRecords_name = "countRecords";

static const ::std::string __Tartarus__iface__DNS__Zone__getRecords_name = "getRecords";

static const ::std::string __Tartarus__iface__DNS__Zone__findRecords_name = "findRecords";

static const ::std::string __Tartarus__iface__DNS__Zone__getSOA_name = "getSOA";

static const ::std::string __Tartarus__iface__DNS__Zone__setSOA_name = "setSOA";

static const ::std::string __Tartarus__iface__DNS__Server__getZones_name = "getZones";

static const ::std::string __Tartarus__iface__DNS__Server__getZone_name = "getZone";

static const ::std::string __Tartarus__iface__DNS__Server__createZone_name = "createZone";

static const ::std::string __Tartarus__iface__DNS__Server__deleteZone_name = "deleteZone";

static const ::std::string __Tartarus__iface__DNS__Server__deleteZoneByRef_name = "deleteZoneByRef";

static const ::std::string __Tartarus__iface__DNS__Server__getOptions_name = "getOptions";

static const ::std::string __Tartarus__iface__DNS__Server__setOptions_name = "setOptions";

static const ::std::string __Tartarus__iface__DNS__Server__changeOptions_name = "changeOptions";

static const ::std::string __Tartarus__iface__DNS__Server__updateHost_name = "updateHost";

static const ::std::string __Tartarus__iface__DNS__Server__updateThisHost_name = "updateThisHost";

::Ice::Object* IceInternal::upCast(::Tartarus::iface::DNS::Zone* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Tartarus::iface::DNS::Zone* p) { return p; }

::Ice::Object* IceInternal::upCast(::Tartarus::iface::DNS::Server* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Tartarus::iface::DNS::Server* p) { return p; }

void
Tartarus::iface::DNS::__read(::IceInternal::BasicStream* __is, ::Tartarus::iface::DNS::ZonePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Tartarus::iface::DNS::Zone;
        v->__copyFrom(proxy);
    }
}

void
Tartarus::iface::DNS::__read(::IceInternal::BasicStream* __is, ::Tartarus::iface::DNS::ServerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Tartarus::iface::DNS::Server;
        v->__copyFrom(proxy);
    }
}

void
Tartarus::iface::DNS::__write(::IceInternal::BasicStream* __os, ::Tartarus::iface::DNS::RecordType v)
{
    __os->write(static_cast< ::Ice::Byte>(v), 21);
}

void
Tartarus::iface::DNS::__read(::IceInternal::BasicStream* __is, ::Tartarus::iface::DNS::RecordType& v)
{
    ::Ice::Byte val;
    __is->read(val, 21);
    v = static_cast< ::Tartarus::iface::DNS::RecordType>(val);
}

bool
Tartarus::iface::DNS::Record::operator==(const Record& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(name != __rhs.name)
    {
        return false;
    }
    if(type != __rhs.type)
    {
        return false;
    }
    if(data != __rhs.data)
    {
        return false;
    }
    if(ttl != __rhs.ttl)
    {
        return false;
    }
    if(prio != __rhs.prio)
    {
        return false;
    }
    return true;
}

bool
Tartarus::iface::DNS::Record::operator<(const Record& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(name < __rhs.name)
    {
        return true;
    }
    else if(__rhs.name < name)
    {
        return false;
    }
    if(type < __rhs.type)
    {
        return true;
    }
    else if(__rhs.type < type)
    {
        return false;
    }
    if(data < __rhs.data)
    {
        return true;
    }
    else if(__rhs.data < data)
    {
        return false;
    }
    if(ttl < __rhs.ttl)
    {
        return true;
    }
    else if(__rhs.ttl < ttl)
    {
        return false;
    }
    if(prio < __rhs.prio)
    {
        return true;
    }
    else if(__rhs.prio < prio)
    {
        return false;
    }
    return false;
}

void
Tartarus::iface::DNS::Record::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(name);
    ::Tartarus::iface::DNS::__write(__os, type);
    __os->write(data);
    __os->write(ttl);
    __os->write(prio);
}

void
Tartarus::iface::DNS::Record::__read(::IceInternal::BasicStream* __is)
{
    __is->read(name);
    ::Tartarus::iface::DNS::__read(__is, type);
    __is->read(data);
    __is->read(ttl);
    __is->read(prio);
}

void
Tartarus::iface::DNS::__writeRecordSeq(::IceInternal::BasicStream* __os, const ::Tartarus::iface::DNS::Record* begin, const ::Tartarus::iface::DNS::Record* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
Tartarus::iface::DNS::__readRecordSeq(::IceInternal::BasicStream* __is, ::Tartarus::iface::DNS::RecordSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 19);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
Tartarus::iface::DNS::SOARecord::operator==(const SOARecord& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(nameserver != __rhs.nameserver)
    {
        return false;
    }
    if(hostmaster != __rhs.hostmaster)
    {
        return false;
    }
    if(serial != __rhs.serial)
    {
        return false;
    }
    if(refresh != __rhs.refresh)
    {
        return false;
    }
    if(retry != __rhs.retry)
    {
        return false;
    }
    if(expire != __rhs.expire)
    {
        return false;
    }
    if(ttl != __rhs.ttl)
    {
        return false;
    }
    return true;
}

bool
Tartarus::iface::DNS::SOARecord::operator<(const SOARecord& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(nameserver < __rhs.nameserver)
    {
        return true;
    }
    else if(__rhs.nameserver < nameserver)
    {
        return false;
    }
    if(hostmaster < __rhs.hostmaster)
    {
        return true;
    }
    else if(__rhs.hostmaster < hostmaster)
    {
        return false;
    }
    if(serial < __rhs.serial)
    {
        return true;
    }
    else if(__rhs.serial < serial)
    {
        return false;
    }
    if(refresh < __rhs.refresh)
    {
        return true;
    }
    else if(__rhs.refresh < refresh)
    {
        return false;
    }
    if(retry < __rhs.retry)
    {
        return true;
    }
    else if(__rhs.retry < retry)
    {
        return false;
    }
    if(expire < __rhs.expire)
    {
        return true;
    }
    else if(__rhs.expire < expire)
    {
        return false;
    }
    if(ttl < __rhs.ttl)
    {
        return true;
    }
    else if(__rhs.ttl < ttl)
    {
        return false;
    }
    return false;
}

void
Tartarus::iface::DNS::SOARecord::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(nameserver);
    __os->write(hostmaster);
    __os->write(serial);
    __os->write(refresh);
    __os->write(retry);
    __os->write(expire);
    __os->write(ttl);
}

void
Tartarus::iface::DNS::SOARecord::__read(::IceInternal::BasicStream* __is)
{
    __is->read(nameserver);
    __is->read(hostmaster);
    __is->read(serial);
    __is->read(refresh);
    __is->read(retry);
    __is->read(expire);
    __is->read(ttl);
}

void
Tartarus::iface::DNS::__writeZoneSeq(::IceInternal::BasicStream* __os, const ::Tartarus::iface::DNS::ZonePrx* begin, const ::Tartarus::iface::DNS::ZonePrx* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(begin[i].get())));
    }
}

void
Tartarus::iface::DNS::__readZoneSeq(::IceInternal::BasicStream* __is, ::Tartarus::iface::DNS::ZoneSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        ::Tartarus::iface::DNS::__read(__is, v[i]);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
Tartarus::iface::DNS::ServerOption::operator==(const ServerOption& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(name != __rhs.name)
    {
        return false;
    }
    if(value != __rhs.value)
    {
        return false;
    }
    return true;
}

bool
Tartarus::iface::DNS::ServerOption::operator<(const ServerOption& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(name < __rhs.name)
    {
        return true;
    }
    else if(__rhs.name < name)
    {
        return false;
    }
    if(value < __rhs.value)
    {
        return true;
    }
    else if(__rhs.value < value)
    {
        return false;
    }
    return false;
}

void
Tartarus::iface::DNS::ServerOption::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(name);
    __os->write(value);
}

void
Tartarus::iface::DNS::ServerOption::__read(::IceInternal::BasicStream* __is)
{
    __is->read(name);
    __is->read(value);
}

void
Tartarus::iface::DNS::__writeServerOptionSeq(::IceInternal::BasicStream* __os, const ::Tartarus::iface::DNS::ServerOption* begin, const ::Tartarus::iface::DNS::ServerOption* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
Tartarus::iface::DNS::__readServerOptionSeq(::IceInternal::BasicStream* __is, ::Tartarus::iface::DNS::ServerOptionSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

::std::string
IceProxy::Tartarus::iface::DNS::Zone::getName(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__getName_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            return __del->getName(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Zone::addRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__addRecord_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            __del->addRecord(r, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Zone::addRecords(const ::Tartarus::iface::DNS::RecordSeq& rs, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__addRecords_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            __del->addRecords(rs, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Zone::clearAll(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__clearAll_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            __del->clearAll(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Zone::replaceRecord(const ::Tartarus::iface::DNS::Record& oldr, const ::Tartarus::iface::DNS::Record& newr, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__replaceRecord_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            __del->replaceRecord(oldr, newr, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Zone::dropRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__dropRecord_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            __del->dropRecord(r, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::Long
IceProxy::Tartarus::iface::DNS::Zone::countRecords(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__countRecords_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            return __del->countRecords(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Tartarus::iface::DNS::RecordSeq
IceProxy::Tartarus::iface::DNS::Zone::getRecords(::Ice::Long limit, ::Ice::Long offset, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__getRecords_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            return __del->getRecords(limit, offset, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Tartarus::iface::DNS::RecordSeq
IceProxy::Tartarus::iface::DNS::Zone::findRecords(const ::std::string& phrase, ::Ice::Long limit, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__findRecords_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            return __del->findRecords(phrase, limit, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Tartarus::iface::DNS::SOARecord
IceProxy::Tartarus::iface::DNS::Zone::getSOA(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__getSOA_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            return __del->getSOA(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Zone::setSOA(const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Zone__setSOA_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Zone* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Zone*>(__delBase.get());
            __del->setSOA(soar, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Tartarus::iface::DNS::Zone::ice_staticId()
{
    return ::Tartarus::iface::DNS::Zone::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Tartarus::iface::DNS::Zone::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Tartarus::iface::DNS::Zone);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Tartarus::iface::DNS::Zone::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Tartarus::iface::DNS::Zone);
}

::IceProxy::Ice::Object*
IceProxy::Tartarus::iface::DNS::Zone::__newInstance() const
{
    return new Zone;
}

::Tartarus::iface::DNS::ZoneSeq
IceProxy::Tartarus::iface::DNS::Server::getZones(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__getZones_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            return __del->getZones(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Tartarus::iface::DNS::ZonePrx
IceProxy::Tartarus::iface::DNS::Server::getZone(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__getZone_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            return __del->getZone(name, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Tartarus::iface::DNS::ZonePrx
IceProxy::Tartarus::iface::DNS::Server::createZone(const ::std::string& name, const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__createZone_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            return __del->createZone(name, soar, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Server::deleteZone(const ::std::string& name, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__deleteZone_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            __del->deleteZone(name, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Server::deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx& proxy, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__deleteZoneByRef_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            __del->deleteZoneByRef(proxy, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Tartarus::iface::DNS::ServerOptionSeq
IceProxy::Tartarus::iface::DNS::Server::getOptions(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__getOptions_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            return __del->getOptions(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Server::setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__setOptions_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            __del->setOptions(opts, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Server::changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__changeOptions_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            __del->changeOptions(opts, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Server::updateHost(const ::std::string& hostname, const ::std::string& addr, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__updateHost_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            __del->updateHost(hostname, addr, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Tartarus::iface::DNS::Server::updateThisHost(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__Tartarus__iface__DNS__Server__updateThisHost_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Tartarus::iface::DNS::Server* __del = dynamic_cast< ::IceDelegate::Tartarus::iface::DNS::Server*>(__delBase.get());
            __del->updateThisHost(__ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Tartarus::iface::DNS::Server::ice_staticId()
{
    return ::Tartarus::iface::DNS::Server::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Tartarus::iface::DNS::Server::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Tartarus::iface::DNS::Server);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Tartarus::iface::DNS::Server::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Tartarus::iface::DNS::Server);
}

::IceProxy::Ice::Object*
IceProxy::Tartarus::iface::DNS::Server::__newInstance() const
{
    return new Server;
}

::std::string
IceDelegateM::Tartarus::iface::DNS::Zone::getName(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__getName_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::std::string __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Zone::addRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__addRecord_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        r.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Zone::addRecords(const ::Tartarus::iface::DNS::RecordSeq& rs, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__addRecords_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(rs.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeRecordSeq(__os, &rs[0], &rs[0] + rs.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Zone::clearAll(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__clearAll_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Zone::replaceRecord(const ::Tartarus::iface::DNS::Record& oldr, const ::Tartarus::iface::DNS::Record& newr, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__replaceRecord_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        oldr.__write(__os);
        newr.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Zone::dropRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__dropRecord_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        r.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::Long
IceDelegateM::Tartarus::iface::DNS::Zone::countRecords(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__countRecords_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::Ice::Long __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::RecordSeq
IceDelegateM::Tartarus::iface::DNS::Zone::getRecords(::Ice::Long limit, ::Ice::Long offset, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__getRecords_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(limit);
        __os->write(offset);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::RecordSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Tartarus::iface::DNS::__readRecordSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::RecordSeq
IceDelegateM::Tartarus::iface::DNS::Zone::findRecords(const ::std::string& phrase, ::Ice::Long limit, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__findRecords_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(phrase);
        __os->write(limit);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::RecordSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Tartarus::iface::DNS::__readRecordSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::SOARecord
IceDelegateM::Tartarus::iface::DNS::Zone::getSOA(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__getSOA_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::SOARecord __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __ret.__read(__is);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Zone::setSOA(const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Zone__setSOA_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        soar.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::ZoneSeq
IceDelegateM::Tartarus::iface::DNS::Server::getZones(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__getZones_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::ZoneSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Tartarus::iface::DNS::__readZoneSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::ZonePrx
IceDelegateM::Tartarus::iface::DNS::Server::getZone(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__getZone_name, ::Ice::Idempotent, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::ZonePrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Tartarus::iface::DNS::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::ZonePrx
IceDelegateM::Tartarus::iface::DNS::Server::createZone(const ::std::string& name, const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__createZone_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
        soar.__write(__os);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::ZonePrx __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Tartarus::iface::DNS::__read(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Server::deleteZone(const ::std::string& name, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__deleteZone_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Server::deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx& proxy, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__deleteZoneByRef_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(proxy.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Tartarus::iface::DNS::ServerOptionSeq
IceDelegateM::Tartarus::iface::DNS::Server::getOptions(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__getOptions_name, ::Ice::Idempotent, __context);
    bool __ok = __og.invoke();
    ::Tartarus::iface::DNS::ServerOptionSeq __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Tartarus::iface::DNS::__readServerOptionSeq(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Server::setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__setOptions_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(opts.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeServerOptionSeq(__os, &opts[0], &opts[0] + opts.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Server::changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__changeOptions_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(opts.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeServerOptionSeq(__os, &opts[0], &opts[0] + opts.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Server::updateHost(const ::std::string& hostname, const ::std::string& addr, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__updateHost_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(hostname);
        __os->write(addr);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Tartarus::iface::DNS::Server::updateThisHost(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Tartarus__iface__DNS__Server__updateThisHost_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Tartarus::iface::core::Error&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        __og.is()->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateD::Tartarus::iface::DNS::Zone::getName(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getName(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__getName_name, ::Ice::Idempotent, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Tartarus::iface::DNS::Zone::addRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_r(r)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->addRecord(_m_r, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::Record& _m_r;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__addRecord_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(r, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Zone::addRecords(const ::Tartarus::iface::DNS::RecordSeq& rs, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::RecordSeq& rs, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_rs(rs)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->addRecords(_m_rs, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::RecordSeq& _m_rs;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__addRecords_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(rs, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Zone::clearAll(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->clearAll(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__clearAll_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Zone::replaceRecord(const ::Tartarus::iface::DNS::Record& oldr, const ::Tartarus::iface::DNS::Record& newr, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::Record& oldr, const ::Tartarus::iface::DNS::Record& newr, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_oldr(oldr),
            _m_newr(newr)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->replaceRecord(_m_oldr, _m_newr, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::Record& _m_oldr;
        const ::Tartarus::iface::DNS::Record& _m_newr;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__replaceRecord_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(oldr, newr, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Zone::dropRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_r(r)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->dropRecord(_m_r, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::Record& _m_r;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__dropRecord_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(r, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::Long
IceDelegateD::Tartarus::iface::DNS::Zone::countRecords(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::Long& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->countRecords(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Ice::Long& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__countRecords_name, ::Ice::Normal, __context);
    ::Ice::Long __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Tartarus::iface::DNS::RecordSeq
IceDelegateD::Tartarus::iface::DNS::Zone::getRecords(::Ice::Long limit, ::Ice::Long offset, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::RecordSeq& __result, ::Ice::Long limit, ::Ice::Long offset, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_limit(limit),
            _m_offset(offset)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getRecords(_m_limit, _m_offset, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::RecordSeq& _result;
        ::Ice::Long _m_limit;
        ::Ice::Long _m_offset;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__getRecords_name, ::Ice::Normal, __context);
    ::Tartarus::iface::DNS::RecordSeq __result;
    try
    {
        _DirectI __direct(__result, limit, offset, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Tartarus::iface::DNS::RecordSeq
IceDelegateD::Tartarus::iface::DNS::Zone::findRecords(const ::std::string& phrase, ::Ice::Long limit, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::RecordSeq& __result, const ::std::string& phrase, ::Ice::Long limit, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_phrase(phrase),
            _m_limit(limit)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->findRecords(_m_phrase, _m_limit, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::RecordSeq& _result;
        const ::std::string& _m_phrase;
        ::Ice::Long _m_limit;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__findRecords_name, ::Ice::Normal, __context);
    ::Tartarus::iface::DNS::RecordSeq __result;
    try
    {
        _DirectI __direct(__result, phrase, limit, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Tartarus::iface::DNS::SOARecord
IceDelegateD::Tartarus::iface::DNS::Zone::getSOA(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::SOARecord& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getSOA(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::SOARecord& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__getSOA_name, ::Ice::Idempotent, __context);
    ::Tartarus::iface::DNS::SOARecord __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Tartarus::iface::DNS::Zone::setSOA(const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_soar(soar)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Zone* servant = dynamic_cast< ::Tartarus::iface::DNS::Zone*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->setSOA(_m_soar, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::SOARecord& _m_soar;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Zone__setSOA_name, ::Ice::Idempotent, __context);
    try
    {
        _DirectI __direct(soar, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Tartarus::iface::DNS::ZoneSeq
IceDelegateD::Tartarus::iface::DNS::Server::getZones(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::ZoneSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getZones(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::ZoneSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__getZones_name, ::Ice::Idempotent, __context);
    ::Tartarus::iface::DNS::ZoneSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Tartarus::iface::DNS::ZonePrx
IceDelegateD::Tartarus::iface::DNS::Server::getZone(const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::ZonePrx& __result, const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getZone(_m_name, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::ZonePrx& _result;
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__getZone_name, ::Ice::Idempotent, __context);
    ::Tartarus::iface::DNS::ZonePrx __result;
    try
    {
        _DirectI __direct(__result, name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Tartarus::iface::DNS::ZonePrx
IceDelegateD::Tartarus::iface::DNS::Server::createZone(const ::std::string& name, const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::ZonePrx& __result, const ::std::string& name, const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_name(name),
            _m_soar(soar)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->createZone(_m_name, _m_soar, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::ZonePrx& _result;
        const ::std::string& _m_name;
        const ::Tartarus::iface::DNS::SOARecord& _m_soar;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__createZone_name, ::Ice::Normal, __context);
    ::Tartarus::iface::DNS::ZonePrx __result;
    try
    {
        _DirectI __direct(__result, name, soar, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Tartarus::iface::DNS::Server::deleteZone(const ::std::string& name, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& name, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_name(name)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->deleteZone(_m_name, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::std::string& _m_name;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__deleteZone_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(name, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Server::deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx& proxy, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::ZonePrx& proxy, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_proxy(proxy)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->deleteZoneByRef(_m_proxy, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::ZonePrx& _m_proxy;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__deleteZoneByRef_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(proxy, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Tartarus::iface::DNS::ServerOptionSeq
IceDelegateD::Tartarus::iface::DNS::Server::getOptions(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Tartarus::iface::DNS::ServerOptionSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->getOptions(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Tartarus::iface::DNS::ServerOptionSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__getOptions_name, ::Ice::Idempotent, __context);
    ::Tartarus::iface::DNS::ServerOptionSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Tartarus::iface::DNS::Server::setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_opts(opts)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->setOptions(_m_opts, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::ServerOptionSeq& _m_opts;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__setOptions_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(opts, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Server::changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_opts(opts)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->changeOptions(_m_opts, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::Tartarus::iface::DNS::ServerOptionSeq& _m_opts;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__changeOptions_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(opts, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Server::updateHost(const ::std::string& hostname, const ::std::string& addr, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& hostname, const ::std::string& addr, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_hostname(hostname),
            _m_addr(addr)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->updateHost(_m_hostname, _m_addr, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        const ::std::string& _m_hostname;
        const ::std::string& _m_addr;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__updateHost_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(hostname, addr, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Tartarus::iface::DNS::Server::updateThisHost(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Tartarus::iface::DNS::Server* servant = dynamic_cast< ::Tartarus::iface::DNS::Server*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                servant->updateThisHost(_current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Tartarus__iface__DNS__Server__updateThisHost_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(__current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Tartarus::iface::core::Error&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::ObjectPtr
Tartarus::iface::DNS::Zone::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Tartarus__iface__DNS__Zone_ids[2] =
{
    "::Ice::Object",
    "::Tartarus::iface::DNS::Zone"
};

bool
Tartarus::iface::DNS::Zone::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Tartarus__iface__DNS__Zone_ids, __Tartarus__iface__DNS__Zone_ids + 2, _s);
}

::std::vector< ::std::string>
Tartarus::iface::DNS::Zone::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Tartarus__iface__DNS__Zone_ids[0], &__Tartarus__iface__DNS__Zone_ids[2]);
}

const ::std::string&
Tartarus::iface::DNS::Zone::ice_id(const ::Ice::Current&) const
{
    return __Tartarus__iface__DNS__Zone_ids[1];
}

const ::std::string&
Tartarus::iface::DNS::Zone::ice_staticId()
{
    return __Tartarus__iface__DNS__Zone_ids[1];
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___getName(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::std::string __ret = getName(__current);
        __os->write(__ret);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___addRecord(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::Record r;
    r.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        addRecord(r, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___addRecords(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::RecordSeq rs;
    ::Tartarus::iface::DNS::__readRecordSeq(__is, rs);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        addRecords(rs, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___clearAll(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        clearAll(__current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___replaceRecord(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::Record oldr;
    ::Tartarus::iface::DNS::Record newr;
    oldr.__read(__is);
    newr.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        replaceRecord(oldr, newr, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___dropRecord(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::Record r;
    r.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        dropRecord(r, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___countRecords(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Ice::Long __ret = countRecords(__current);
        __os->write(__ret);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___getRecords(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::Long limit;
    ::Ice::Long offset;
    __is->read(limit);
    __is->read(offset);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::RecordSeq __ret = getRecords(limit, offset, __current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeRecordSeq(__os, &__ret[0], &__ret[0] + __ret.size());
        }
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___findRecords(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string phrase;
    ::Ice::Long limit;
    __is->read(phrase);
    __is->read(limit);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::RecordSeq __ret = findRecords(phrase, limit, __current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeRecordSeq(__os, &__ret[0], &__ret[0] + __ret.size());
        }
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___getSOA(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::SOARecord __ret = getSOA(__current);
        __ret.__write(__os);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::___setSOA(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::SOARecord soar;
    soar.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        setSOA(soar, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Tartarus__iface__DNS__Zone_all[] =
{
    "addRecord",
    "addRecords",
    "clearAll",
    "countRecords",
    "dropRecord",
    "findRecords",
    "getName",
    "getRecords",
    "getSOA",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "replaceRecord",
    "setSOA"
};

::Ice::DispatchStatus
Tartarus::iface::DNS::Zone::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Tartarus__iface__DNS__Zone_all, __Tartarus__iface__DNS__Zone_all + 15, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Tartarus__iface__DNS__Zone_all)
    {
        case 0:
        {
            return ___addRecord(in, current);
        }
        case 1:
        {
            return ___addRecords(in, current);
        }
        case 2:
        {
            return ___clearAll(in, current);
        }
        case 3:
        {
            return ___countRecords(in, current);
        }
        case 4:
        {
            return ___dropRecord(in, current);
        }
        case 5:
        {
            return ___findRecords(in, current);
        }
        case 6:
        {
            return ___getName(in, current);
        }
        case 7:
        {
            return ___getRecords(in, current);
        }
        case 8:
        {
            return ___getSOA(in, current);
        }
        case 9:
        {
            return ___ice_id(in, current);
        }
        case 10:
        {
            return ___ice_ids(in, current);
        }
        case 11:
        {
            return ___ice_isA(in, current);
        }
        case 12:
        {
            return ___ice_ping(in, current);
        }
        case 13:
        {
            return ___replaceRecord(in, current);
        }
        case 14:
        {
            return ___setSOA(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Tartarus::iface::DNS::Zone::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Tartarus::iface::DNS::Zone::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Tartarus::iface::DNS::Zone::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Tartarus::iface::DNS::Zone was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::DNS::Zone::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Tartarus::iface::DNS::Zone was not generated with stream support";
    throw ex;
}

void 
Tartarus::iface::DNS::__patch__ZonePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Tartarus::iface::DNS::ZonePtr* p = static_cast< ::Tartarus::iface::DNS::ZonePtr*>(__addr);
    assert(p);
    *p = ::Tartarus::iface::DNS::ZonePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Tartarus::iface::DNS::Zone::ice_staticId(), v->ice_id());
    }
}

bool
Tartarus::iface::DNS::operator==(const ::Tartarus::iface::DNS::Zone& l, const ::Tartarus::iface::DNS::Zone& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Tartarus::iface::DNS::operator<(const ::Tartarus::iface::DNS::Zone& l, const ::Tartarus::iface::DNS::Zone& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Tartarus::iface::DNS::Server::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Tartarus__iface__DNS__Server_ids[2] =
{
    "::Ice::Object",
    "::Tartarus::iface::DNS::Server"
};

bool
Tartarus::iface::DNS::Server::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Tartarus__iface__DNS__Server_ids, __Tartarus__iface__DNS__Server_ids + 2, _s);
}

::std::vector< ::std::string>
Tartarus::iface::DNS::Server::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Tartarus__iface__DNS__Server_ids[0], &__Tartarus__iface__DNS__Server_ids[2]);
}

const ::std::string&
Tartarus::iface::DNS::Server::ice_id(const ::Ice::Current&) const
{
    return __Tartarus__iface__DNS__Server_ids[1];
}

const ::std::string&
Tartarus::iface::DNS::Server::ice_staticId()
{
    return __Tartarus__iface__DNS__Server_ids[1];
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___getZones(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::ZoneSeq __ret = getZones(__current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeZoneSeq(__os, &__ret[0], &__ret[0] + __ret.size());
        }
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___getZone(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    __is->read(name);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::ZonePrx __ret = getZone(name, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___createZone(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    ::Tartarus::iface::DNS::SOARecord soar;
    __is->read(name);
    soar.__read(__is);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::ZonePrx __ret = createZone(name, soar, __current);
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(__ret.get())));
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___deleteZone(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    __is->read(name);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        deleteZone(name, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___deleteZoneByRef(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::ZonePrx proxy;
    ::Tartarus::iface::DNS::__read(__is, proxy);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        deleteZoneByRef(proxy, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___getOptions(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Tartarus::iface::DNS::ServerOptionSeq __ret = getOptions(__current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Tartarus::iface::DNS::__writeServerOptionSeq(__os, &__ret[0], &__ret[0] + __ret.size());
        }
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___setOptions(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::ServerOptionSeq opts;
    ::Tartarus::iface::DNS::__readServerOptionSeq(__is, opts);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        setOptions(opts, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___changeOptions(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Tartarus::iface::DNS::ServerOptionSeq opts;
    ::Tartarus::iface::DNS::__readServerOptionSeq(__is, opts);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        changeOptions(opts, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___updateHost(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string hostname;
    ::std::string addr;
    __is->read(hostname);
    __is->read(addr);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        updateHost(hostname, addr, __current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::___updateThisHost(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        updateThisHost(__current);
    }
    catch(const ::Tartarus::iface::core::Error& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Tartarus__iface__DNS__Server_all[] =
{
    "changeOptions",
    "createZone",
    "deleteZone",
    "deleteZoneByRef",
    "getOptions",
    "getZone",
    "getZones",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "setOptions",
    "updateHost",
    "updateThisHost"
};

::Ice::DispatchStatus
Tartarus::iface::DNS::Server::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Tartarus__iface__DNS__Server_all, __Tartarus__iface__DNS__Server_all + 14, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Tartarus__iface__DNS__Server_all)
    {
        case 0:
        {
            return ___changeOptions(in, current);
        }
        case 1:
        {
            return ___createZone(in, current);
        }
        case 2:
        {
            return ___deleteZone(in, current);
        }
        case 3:
        {
            return ___deleteZoneByRef(in, current);
        }
        case 4:
        {
            return ___getOptions(in, current);
        }
        case 5:
        {
            return ___getZone(in, current);
        }
        case 6:
        {
            return ___getZones(in, current);
        }
        case 7:
        {
            return ___ice_id(in, current);
        }
        case 8:
        {
            return ___ice_ids(in, current);
        }
        case 9:
        {
            return ___ice_isA(in, current);
        }
        case 10:
        {
            return ___ice_ping(in, current);
        }
        case 11:
        {
            return ___setOptions(in, current);
        }
        case 12:
        {
            return ___updateHost(in, current);
        }
        case 13:
        {
            return ___updateThisHost(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Tartarus::iface::DNS::Server::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Tartarus::iface::DNS::Server::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Tartarus::iface::DNS::Server::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Tartarus::iface::DNS::Server was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::DNS::Server::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Tartarus::iface::DNS::Server was not generated with stream support";
    throw ex;
}

void 
Tartarus::iface::DNS::__patch__ServerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Tartarus::iface::DNS::ServerPtr* p = static_cast< ::Tartarus::iface::DNS::ServerPtr*>(__addr);
    assert(p);
    *p = ::Tartarus::iface::DNS::ServerPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Tartarus::iface::DNS::Server::ice_staticId(), v->ice_id());
    }
}

bool
Tartarus::iface::DNS::operator==(const ::Tartarus::iface::DNS::Server& l, const ::Tartarus::iface::DNS::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Tartarus::iface::DNS::operator<(const ::Tartarus::iface::DNS::Server& l, const ::Tartarus::iface::DNS::Server& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
