// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `exceptions.ice'

#include <core/exceptions.h>
#include <Ice/BasicStream.h>
#include <Ice/Object.h>
#include <Ice/LocalException.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

Tartarus::iface::core::Error::Error(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Tartarus::iface::core::Error::~Error() throw()
{
}

static const char* __Tartarus__iface__core__Error_name = "Tartarus::iface::core::Error";

::std::string
Tartarus::iface::core::Error::ice_name() const
{
    return __Tartarus__iface__core__Error_name;
}

::Ice::Exception*
Tartarus::iface::core::Error::ice_clone() const
{
    return new Error(*this);
}

void
Tartarus::iface::core::Error::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::Error::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::Error"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Tartarus::iface::core::Error::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Tartarus::iface::core::Error::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::Error was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::Error::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::Error was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__Error : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::Error();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__Error__Ptr = new __F__Tartarus__iface__core__Error;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::Error::ice_factory()
{
    return __F__Tartarus__iface__core__Error__Ptr;
}

class __F__Tartarus__iface__core__Error__Init
{
public:

    __F__Tartarus__iface__core__Error__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::Error", ::Tartarus::iface::core::Error::ice_factory());
    }

    ~__F__Tartarus__iface__core__Error__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::Error");
    }
};

static __F__Tartarus__iface__core__Error__Init __F__Tartarus__iface__core__Error__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__Error__initializer() {} }
#endif

Tartarus::iface::core::ConfigError::ConfigError(const ::std::string& __ice_reason, const ::std::string& __ice_property) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error(__ice_reason),
#else
    ::Tartarus::iface::core::Error(__ice_reason),
#endif
    property(__ice_property)
{
}

Tartarus::iface::core::ConfigError::~ConfigError() throw()
{
}

static const char* __Tartarus__iface__core__ConfigError_name = "Tartarus::iface::core::ConfigError";

::std::string
Tartarus::iface::core::ConfigError::ice_name() const
{
    return __Tartarus__iface__core__ConfigError_name;
}

::Ice::Exception*
Tartarus::iface::core::ConfigError::ice_clone() const
{
    return new ConfigError(*this);
}

void
Tartarus::iface::core::ConfigError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::ConfigError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::ConfigError"), false);
    __os->startWriteSlice();
    __os->write(property);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__write(__os);
#else
    ::Tartarus::iface::core::Error::__write(__os);
#endif
}

void
Tartarus::iface::core::ConfigError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(property);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__read(__is, true);
#else
    ::Tartarus::iface::core::Error::__read(__is, true);
#endif
}

void
Tartarus::iface::core::ConfigError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::ConfigError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::ConfigError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::ConfigError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__ConfigError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::ConfigError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__ConfigError__Ptr = new __F__Tartarus__iface__core__ConfigError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::ConfigError::ice_factory()
{
    return __F__Tartarus__iface__core__ConfigError__Ptr;
}

class __F__Tartarus__iface__core__ConfigError__Init
{
public:

    __F__Tartarus__iface__core__ConfigError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::ConfigError", ::Tartarus::iface::core::ConfigError::ice_factory());
    }

    ~__F__Tartarus__iface__core__ConfigError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::ConfigError");
    }
};

static __F__Tartarus__iface__core__ConfigError__Init __F__Tartarus__iface__core__ConfigError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__ConfigError__initializer() {} }
#endif

Tartarus::iface::core::ValueError::ValueError(const ::std::string& __ice_reason, const ::std::string& __ice_value) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error(__ice_reason),
#else
    ::Tartarus::iface::core::Error(__ice_reason),
#endif
    value(__ice_value)
{
}

Tartarus::iface::core::ValueError::~ValueError() throw()
{
}

static const char* __Tartarus__iface__core__ValueError_name = "Tartarus::iface::core::ValueError";

::std::string
Tartarus::iface::core::ValueError::ice_name() const
{
    return __Tartarus__iface__core__ValueError_name;
}

::Ice::Exception*
Tartarus::iface::core::ValueError::ice_clone() const
{
    return new ValueError(*this);
}

void
Tartarus::iface::core::ValueError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::ValueError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::ValueError"), false);
    __os->startWriteSlice();
    __os->write(value);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__write(__os);
#else
    ::Tartarus::iface::core::Error::__write(__os);
#endif
}

void
Tartarus::iface::core::ValueError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(value);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__read(__is, true);
#else
    ::Tartarus::iface::core::Error::__read(__is, true);
#endif
}

void
Tartarus::iface::core::ValueError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::ValueError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::ValueError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::ValueError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__ValueError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::ValueError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__ValueError__Ptr = new __F__Tartarus__iface__core__ValueError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::ValueError::ice_factory()
{
    return __F__Tartarus__iface__core__ValueError__Ptr;
}

class __F__Tartarus__iface__core__ValueError__Init
{
public:

    __F__Tartarus__iface__core__ValueError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::ValueError", ::Tartarus::iface::core::ValueError::ice_factory());
    }

    ~__F__Tartarus__iface__core__ValueError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::ValueError");
    }
};

static __F__Tartarus__iface__core__ValueError__Init __F__Tartarus__iface__core__ValueError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__ValueError__initializer() {} }
#endif

Tartarus::iface::core::DBError::DBError(const ::std::string& __ice_reason, const ::std::string& __ice_response) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error(__ice_reason),
#else
    ::Tartarus::iface::core::Error(__ice_reason),
#endif
    response(__ice_response)
{
}

Tartarus::iface::core::DBError::~DBError() throw()
{
}

static const char* __Tartarus__iface__core__DBError_name = "Tartarus::iface::core::DBError";

::std::string
Tartarus::iface::core::DBError::ice_name() const
{
    return __Tartarus__iface__core__DBError_name;
}

::Ice::Exception*
Tartarus::iface::core::DBError::ice_clone() const
{
    return new DBError(*this);
}

void
Tartarus::iface::core::DBError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::DBError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::DBError"), false);
    __os->startWriteSlice();
    __os->write(response);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__write(__os);
#else
    ::Tartarus::iface::core::Error::__write(__os);
#endif
}

void
Tartarus::iface::core::DBError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(response);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__read(__is, true);
#else
    ::Tartarus::iface::core::Error::__read(__is, true);
#endif
}

void
Tartarus::iface::core::DBError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::DBError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::DBError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::DBError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__DBError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::DBError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__DBError__Ptr = new __F__Tartarus__iface__core__DBError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::DBError::ice_factory()
{
    return __F__Tartarus__iface__core__DBError__Ptr;
}

class __F__Tartarus__iface__core__DBError__Init
{
public:

    __F__Tartarus__iface__core__DBError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::DBError", ::Tartarus::iface::core::DBError::ice_factory());
    }

    ~__F__Tartarus__iface__core__DBError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::DBError");
    }
};

static __F__Tartarus__iface__core__DBError__Init __F__Tartarus__iface__core__DBError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__DBError__initializer() {} }
#endif

Tartarus::iface::core::NotFoundError::NotFoundError(const ::std::string& __ice_reason, const ::std::string& __ice_response) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError(__ice_reason, __ice_response)
#else
    ::Tartarus::iface::core::DBError(__ice_reason, __ice_response)
#endif
{
}

Tartarus::iface::core::NotFoundError::~NotFoundError() throw()
{
}

static const char* __Tartarus__iface__core__NotFoundError_name = "Tartarus::iface::core::NotFoundError";

::std::string
Tartarus::iface::core::NotFoundError::ice_name() const
{
    return __Tartarus__iface__core__NotFoundError_name;
}

::Ice::Exception*
Tartarus::iface::core::NotFoundError::ice_clone() const
{
    return new NotFoundError(*this);
}

void
Tartarus::iface::core::NotFoundError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::NotFoundError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::NotFoundError"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError::__write(__os);
#else
    ::Tartarus::iface::core::DBError::__write(__os);
#endif
}

void
Tartarus::iface::core::NotFoundError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError::__read(__is, true);
#else
    ::Tartarus::iface::core::DBError::__read(__is, true);
#endif
}

void
Tartarus::iface::core::NotFoundError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::NotFoundError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::NotFoundError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::NotFoundError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__NotFoundError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::NotFoundError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__NotFoundError__Ptr = new __F__Tartarus__iface__core__NotFoundError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::NotFoundError::ice_factory()
{
    return __F__Tartarus__iface__core__NotFoundError__Ptr;
}

class __F__Tartarus__iface__core__NotFoundError__Init
{
public:

    __F__Tartarus__iface__core__NotFoundError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::NotFoundError", ::Tartarus::iface::core::NotFoundError::ice_factory());
    }

    ~__F__Tartarus__iface__core__NotFoundError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::NotFoundError");
    }
};

static __F__Tartarus__iface__core__NotFoundError__Init __F__Tartarus__iface__core__NotFoundError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__NotFoundError__initializer() {} }
#endif

Tartarus::iface::core::AlreadyExistsError::AlreadyExistsError(const ::std::string& __ice_reason, const ::std::string& __ice_response) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError(__ice_reason, __ice_response)
#else
    ::Tartarus::iface::core::DBError(__ice_reason, __ice_response)
#endif
{
}

Tartarus::iface::core::AlreadyExistsError::~AlreadyExistsError() throw()
{
}

static const char* __Tartarus__iface__core__AlreadyExistsError_name = "Tartarus::iface::core::AlreadyExistsError";

::std::string
Tartarus::iface::core::AlreadyExistsError::ice_name() const
{
    return __Tartarus__iface__core__AlreadyExistsError_name;
}

::Ice::Exception*
Tartarus::iface::core::AlreadyExistsError::ice_clone() const
{
    return new AlreadyExistsError(*this);
}

void
Tartarus::iface::core::AlreadyExistsError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::AlreadyExistsError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::AlreadyExistsError"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError::__write(__os);
#else
    ::Tartarus::iface::core::DBError::__write(__os);
#endif
}

void
Tartarus::iface::core::AlreadyExistsError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError::__read(__is, true);
#else
    ::Tartarus::iface::core::DBError::__read(__is, true);
#endif
}

void
Tartarus::iface::core::AlreadyExistsError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::AlreadyExistsError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::AlreadyExistsError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::AlreadyExistsError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__AlreadyExistsError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::AlreadyExistsError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__AlreadyExistsError__Ptr = new __F__Tartarus__iface__core__AlreadyExistsError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::AlreadyExistsError::ice_factory()
{
    return __F__Tartarus__iface__core__AlreadyExistsError__Ptr;
}

class __F__Tartarus__iface__core__AlreadyExistsError__Init
{
public:

    __F__Tartarus__iface__core__AlreadyExistsError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::AlreadyExistsError", ::Tartarus::iface::core::AlreadyExistsError::ice_factory());
    }

    ~__F__Tartarus__iface__core__AlreadyExistsError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::AlreadyExistsError");
    }
};

static __F__Tartarus__iface__core__AlreadyExistsError__Init __F__Tartarus__iface__core__AlreadyExistsError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__AlreadyExistsError__initializer() {} }
#endif

Tartarus::iface::core::InternalError::InternalError(const ::std::string& __ice_reason, const ::std::string& __ice_response) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError(__ice_reason, __ice_response)
#else
    ::Tartarus::iface::core::DBError(__ice_reason, __ice_response)
#endif
{
}

Tartarus::iface::core::InternalError::~InternalError() throw()
{
}

static const char* __Tartarus__iface__core__InternalError_name = "Tartarus::iface::core::InternalError";

::std::string
Tartarus::iface::core::InternalError::ice_name() const
{
    return __Tartarus__iface__core__InternalError_name;
}

::Ice::Exception*
Tartarus::iface::core::InternalError::ice_clone() const
{
    return new InternalError(*this);
}

void
Tartarus::iface::core::InternalError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::InternalError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::InternalError"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError::__write(__os);
#else
    ::Tartarus::iface::core::DBError::__write(__os);
#endif
}

void
Tartarus::iface::core::InternalError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    DBError::__read(__is, true);
#else
    ::Tartarus::iface::core::DBError::__read(__is, true);
#endif
}

void
Tartarus::iface::core::InternalError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::InternalError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::InternalError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::InternalError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__InternalError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::InternalError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__InternalError__Ptr = new __F__Tartarus__iface__core__InternalError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::InternalError::ice_factory()
{
    return __F__Tartarus__iface__core__InternalError__Ptr;
}

class __F__Tartarus__iface__core__InternalError__Init
{
public:

    __F__Tartarus__iface__core__InternalError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::InternalError", ::Tartarus::iface::core::InternalError::ice_factory());
    }

    ~__F__Tartarus__iface__core__InternalError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::InternalError");
    }
};

static __F__Tartarus__iface__core__InternalError__Init __F__Tartarus__iface__core__InternalError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__InternalError__initializer() {} }
#endif

Tartarus::iface::core::PermissionError::PermissionError(const ::std::string& __ice_reason, const ::std::string& __ice_operation, const ::std::string& __ice_agent) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error(__ice_reason),
#else
    ::Tartarus::iface::core::Error(__ice_reason),
#endif
    operation(__ice_operation),
    agent(__ice_agent)
{
}

Tartarus::iface::core::PermissionError::~PermissionError() throw()
{
}

static const char* __Tartarus__iface__core__PermissionError_name = "Tartarus::iface::core::PermissionError";

::std::string
Tartarus::iface::core::PermissionError::ice_name() const
{
    return __Tartarus__iface__core__PermissionError_name;
}

::Ice::Exception*
Tartarus::iface::core::PermissionError::ice_clone() const
{
    return new PermissionError(*this);
}

void
Tartarus::iface::core::PermissionError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::PermissionError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::PermissionError"), false);
    __os->startWriteSlice();
    __os->write(operation);
    __os->write(agent);
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__write(__os);
#else
    ::Tartarus::iface::core::Error::__write(__os);
#endif
}

void
Tartarus::iface::core::PermissionError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(operation);
    __is->read(agent);
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__read(__is, true);
#else
    ::Tartarus::iface::core::Error::__read(__is, true);
#endif
}

void
Tartarus::iface::core::PermissionError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::PermissionError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::PermissionError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::PermissionError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__PermissionError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::PermissionError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__PermissionError__Ptr = new __F__Tartarus__iface__core__PermissionError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::PermissionError::ice_factory()
{
    return __F__Tartarus__iface__core__PermissionError__Ptr;
}

class __F__Tartarus__iface__core__PermissionError__Init
{
public:

    __F__Tartarus__iface__core__PermissionError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::PermissionError", ::Tartarus::iface::core::PermissionError::ice_factory());
    }

    ~__F__Tartarus__iface__core__PermissionError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::PermissionError");
    }
};

static __F__Tartarus__iface__core__PermissionError__Init __F__Tartarus__iface__core__PermissionError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__PermissionError__initializer() {} }
#endif

Tartarus::iface::core::RuntimeError::RuntimeError(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error(__ice_reason)
#else
    ::Tartarus::iface::core::Error(__ice_reason)
#endif
{
}

Tartarus::iface::core::RuntimeError::~RuntimeError() throw()
{
}

static const char* __Tartarus__iface__core__RuntimeError_name = "Tartarus::iface::core::RuntimeError";

::std::string
Tartarus::iface::core::RuntimeError::ice_name() const
{
    return __Tartarus__iface__core__RuntimeError_name;
}

::Ice::Exception*
Tartarus::iface::core::RuntimeError::ice_clone() const
{
    return new RuntimeError(*this);
}

void
Tartarus::iface::core::RuntimeError::ice_throw() const
{
    throw *this;
}

void
Tartarus::iface::core::RuntimeError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Tartarus::iface::core::RuntimeError"), false);
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__write(__os);
#else
    ::Tartarus::iface::core::Error::__write(__os);
#endif
}

void
Tartarus::iface::core::RuntimeError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Error::__read(__is, true);
#else
    ::Tartarus::iface::core::Error::__read(__is, true);
#endif
}

void
Tartarus::iface::core::RuntimeError::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::RuntimeError was not generated with stream support";
    throw ex;
}

void
Tartarus::iface::core::RuntimeError::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Tartarus::iface::core::RuntimeError was not generated with stream support";
    throw ex;
}

struct __F__Tartarus__iface__core__RuntimeError : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Tartarus::iface::core::RuntimeError();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Tartarus__iface__core__RuntimeError__Ptr = new __F__Tartarus__iface__core__RuntimeError;

const ::IceInternal::UserExceptionFactoryPtr&
Tartarus::iface::core::RuntimeError::ice_factory()
{
    return __F__Tartarus__iface__core__RuntimeError__Ptr;
}

class __F__Tartarus__iface__core__RuntimeError__Init
{
public:

    __F__Tartarus__iface__core__RuntimeError__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Tartarus::iface::core::RuntimeError", ::Tartarus::iface::core::RuntimeError::ice_factory());
    }

    ~__F__Tartarus__iface__core__RuntimeError__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Tartarus::iface::core::RuntimeError");
    }
};

static __F__Tartarus__iface__core__RuntimeError__Init __F__Tartarus__iface__core__RuntimeError__i;

#ifdef __APPLE__
extern "C" { void __F__Tartarus__iface__core__RuntimeError__initializer() {} }
#endif
